/******************************************************************************
 *            echecs_liste_chainee.c                                          *
 *                                                                            *
 *  Copyright  2006  gerald.dumas                                             *
 *  linechec@laposte.net                                                      *
 ******************************************************************************
 *                                                                            *
 *  This program is free software; you can redistribute it and/or modify      *
 *  it under the terms of the GNU General Public License as published by      *
 *  the Free Software Foundation; either version 2 of the License, or         *
 *  any later version.                                                        *
 *                                                                            *
 *  This program is distributed in the hope that it will be useful,           *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU General Public License for more details.                              *
 *                                                                            *
 *  You should have received a copy of the GNU General Public License         *
 *  along with this program; if not, write to the Free Software               *
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.*
 ******************************************************************************/

/* Fonctions d'aide à la gestion de la liste des coups jouables */

#include "echecs_liste_chainee.h"

int
longueur_par_couleur_dans_liste (GList * liste_coups_jouables, int couleur)
{
  int nombre = 0;
  GList *liste = NULL;
  register int x, y;

  liste = g_list_first (liste_coups_jouables);
  y = g_list_length (liste);
  if (y > 0)
    {
      for (x = 0; x < y; x++)
	{
	  if (((struct struct_coups_jouables *) (liste->data))->couleur ==
	      couleur
	      && ((struct struct_coups_jouables *) (liste->data))->coup_ami ==
	      FALSE)
	    nombre++;
	  liste = g_list_next (liste);
	}
    }
  return nombre;
}

/*
gboolean le_test_est_vrai(GList *liste,int variable_triee,int ordre)
{
	GList *liste_suivant=liste->next;

	switch (variable_triee)
	{
		case POS_PIECE_TAB :
		{
			if (ordre==CROISSANT)
			{
//				if (ptr->pos_piece_tab<liste->pos_piece_tab) return true;
			}
			else
			{
//				if (ptr->pos_piece_tab>liste->pos_piece_tab) return true;
			}
			break;
		}

		case VALEUR_COUP :
		{
			if (ordre==CROISSANT)
			{
//				if (ptr->valeur_coup<liste->valeur_coup) return true;
			}
			else
			{
//				if (ptr->valeur_coup>liste->valeur_coup) return true;
			}
			break;
		}

		case NBRE_COUPS_ADVERSE :
		{

			if (ordre==CROISSANT)
			{
				if (((_coups_jouables*)(liste->data))->nbre_coups_adverse>
					((_coups_jouables*)(liste_suivant->data))->nbre_coups_adverse)
					return true;
			}
			else
			{

			}
		}
	}
	return false;
}
*/
gint
compare (gconstpointer a, gconstpointer b)
{
  struct struct_coups_jouables *donnee_ref =
    (struct struct_coups_jouables *) a;
  struct struct_coups_jouables *donnee_testee =
    (struct struct_coups_jouables *) b;

  if (donnee_testee->nbre_coups_adverse < donnee_ref->nbre_coups_adverse)
    return 1;
  else if (donnee_testee->nbre_coups_adverse > donnee_ref->nbre_coups_adverse)
    return -1;
  else
    return 0;
}

GList *
trier_liste (GList * liste, int variable_triee, int ordre)
{
// La variable "variable triee" n'est pour l'instant pas traitée.
  if (ordre == CROISSANT)
    liste = g_list_sort (liste, (GCompareFunc) compare);
  return liste;
}

void
vider_liste (GList * liste_a_supp)
{
  g_list_foreach (liste_a_supp, (GFunc) g_free, NULL);
  g_list_free (liste_a_supp);
}
